<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Module_apps {

        var $app_version = '1.0';
        var $app_name = 'apps';
        var $app_title = 'Apps';
        var $app_folder = 'apps';
        var $app_description = 'Author: Deep Arora <br> Support: <a href=http://sitemanpro.com/community target=_New>Click here</a> <br> Used for apps management.';

        /**************************************************/
        /***************  GETTER FUNCTIONS ****************/
        /**************************************************/
        function get_version()
        {
            return $this->app_version;
        }
        function get_app_name()
        {
            return $this->app_name;
        }
        function get_app_title()
        {
            return $this->app_title;
        }
        function get_app_description()
        {
            return $this->app_description;
        }
        function get_folder()
        {
            return $this->app_folder;
        }


        /**************************************************/
        /***************  INSTALL FUNCTION ****************/
        /**************************************************/
	function install()
	{
                $sql[] = "INSERT INTO `global_modules` (title, description, flg_enable, ordering, folder_name, file_name, icon, version) VALUES ('". ucfirst($this->app_name) ."', '". $this->app_description ."', 'Y', 998, '". $this->app_folder ."', 'manager', 'module-apps.gif', ". $this->app_version .")";
		foreach ($sql as $query)
		{
                    smp_execute($query);
		}

                unset($sql); //unset sql array to clear any previous queries;

                $module_id = smp_lookup('module_id', 'global_modules', 'LOWER(title) = \''. $this->app_name .'\'');

                $sql[] = "INSERT INTO `global_submodules` (title, description, module_id, ordering, flg_enable) VALUES ('Manager', 'Apps Manager', $module_id, 0, 'Y')";

                foreach ($sql as $query)
		{
                    smp_execute($query);
		}

                unset($sql); //unset sql array to clear any previous queries;

                $submodule_id = smp_lookup('submodule_id', 'global_submodules', 'LOWER(title) = \'manager\' AND module_id = ' . $module_id);

                if($submodule_id){

                    $sql[] = "INSERT INTO `global_submodule_files` (submodule_id, folder_name, file_name) VALUES ($submodule_id, '". $this->app_folder . "', 'manager')";
                    $sql[] = "INSERT INTO `mapping_role_modules` (role_id, submodule_id, module_id, perm_view, perm_add, perm_edit, perm_delete, perm_approve_self, perm_approve_others) VALUES (1, $submodule_id, $module_id, 1, 1, 1, 1, 1, 1)";

                    $sql[] = "INSERT INTO `global_meta` (meta_name, meta_type, meta_key, meta_value) VALUES ('manager', 'module', 'page_title', 'Apps Management')";
                    $sql[] = "INSERT INTO `global_meta` (meta_name, meta_type, meta_key, meta_value) VALUES ('manager', 'module', 'page_description', 'Manage available applications and upgrades')";

                    foreach ($sql as $query)
                    {
                        smp_execute($query);
                    }

                    unset($sql); //unset sql array to clear any previous queries;
                }
		return TRUE;
	}


        /**************************************************/
        /***************  DISABLE FUNCTION ****************/
        /**************************************************/
	function disable()
	{
                $sql[] = "";
		foreach ($sql as $query)
		{
			smp_execute($query);
		}
		return FALSE;
	}

        /**************************************************/
        /***************  ACTIVATE FUNCTION ****************/
        /**************************************************/
        function activate()
	{
		$sql[] = "";
		foreach ($sql as $query)
		{
			smp_execute($query);
		}
		return FALSE;
	}

        /**************************************************/
        /***************  UNINSTALL FUNCTION ****************/
        /**************************************************/
	function uninstall()
	{
		$sql[] = "";
		foreach ($sql as $query)
		{
			smp_execute($query);
		}
		return FALSE;
	}



        /**************************************************/
        /***************  UPGRADE FUNCTION ****************/
        /**************************************************/
	function upgrade()
	{
            $current_version = smp_lookup('version', 'global_modules', 'LOWER(title) = \''. $this->app_name .'\'');
            $module_id = smp_lookup('module_id', 'global_modules', 'LOWER(title) = \''. $this->app_name .'\'');
            
            if ($current_version == $this->app_version)
            {
                return TRUE;
            }

            /* Upgrade to Version 1.1 */
            if ($current_version < 1.1)
            {
                $sql[] = "";

                foreach ($sql as $query)
		{
			smp_execute($query);
		}
            }

            return TRUE;
	}


}
// END CLASS

/* End of file module_apps.php */
/* Location: ./app/modules/apps/module_apps.php */