<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Cron extends Controller {

    function __construct() {
            parent::Controller();
            $this->load->model($this->config->item('shop_model'));
            $this->load->model($this->config->item('smp_model'));
    }

    //---------------------------------------------------------------

    //<editor-fold desc="FUNCTION DESCRIPTION: RUN THE SYSTEM FUNCTIONS">
    /*
     * Function: execute
     * Description: Main cron entry function
     * ##############################################################
     * Written: 12/03/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    //</editor-fold>
    function execute($key = '')
    {
        $api_key = smp_lookup("key_value", $this->config->item('tbl_config'), "key_name = 'API_KEY'");
        if($api_key == $key){
            echo "Starting CRON Tasks......";
            smp_cron_subscriptions();
        }
        else{
            echo "Sorry, an invalid api key provided.....please logon to admin panel to get your api key.";
        }
        
    }
}

/* End of file cron.php */
/* Location: ./app/controllers/socket/cron.php */