<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Meta_model extends Model {

    function Meta_model()
    {
            parent::Model();
    }

    //---------------------------------------------------------------

    /**
     * Function: get_page_meta
     * Description: Get page meta
     * ##############################################################
     * Written: 01/25/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function get_page_meta($module_name) {
        $this->db->select('*');
        $this->db->from('global_meta');
        $this->db->where('meta_name', $module_name);
        $this->db->where('meta_type', 'module');
        $this->db->order_by('meta_key', 'ASC');

        $query = $this->db->get();

        if ($query->num_rows() > 0)
        {
                $result = $query->result();
                return $result;
        }
        return 0;
    }
    //---------------------------------------------------------------

}

?>
