<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Rule_model extends Model {

    function Rule_model()
    {
            parent::Model();
    }

    //---------------------------------------------------------------

    /**
     * Function: get_rules
     * Description: Get form rules
     * ##############################################################
     * Written: 01/26/2010
     * Author: Deep Arora
     * --------------------------------------------------------------
     * Update Log:
     * --------------------------------------------------------------
     * ##############################################################
     * @access public
     * @return void
     */
    function get_rules($rule_name) {
        $this->db->select('field_name, field_label, field_rule');
        $this->db->from('global_rules');
        $where_additional = "rule_name IN ('" . $rule_name . "')";
        $this->db->where($where_additional);
        
        $query = $this->db->get();

        if ($query->num_rows() > 0)
        {
            foreach ($query->result() as $row)
            {
                $config[] = array(
                         'field'   => $row->field_name,
                         'label'   => $row->field_label,
                         'rules'   => $row->field_rule
                );
            }
            $rules_config = $config;
            return $rules_config;
        }
        return 0;
    }
}

?>
