<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/**
 * Pointsmanager Library
 *
 * @author      Deep Arora
 * @copyright   Copyright (c) SiteManPro.com
 *
 */

class Pointsmanager{

    var $CI;

    function award_points($data = '')
    {
        if ($data == '')
            return $data;

        //print_r($data);
        $this->CI =& get_instance();
        $award_points = smp_lookup("award_points", $this->CI->config->item('tbl_products'), "product_id = " . $data['product_id']);
        if($award_points > 0){
            $points_balance = smp_lookup("points_balance", $this->CI->config->item('tbl_users'), "user_id = " . $data['user_id']);
            $points_total = smp_lookup("points_total", $this->CI->config->item('tbl_users'), "user_id = " . $data['user_id']);

            $this->CI->db->where('user_id = ' . $data['user_id']);
            $field_array['points_balance'] = $points_balance + $award_points;
            $field_array['points_total'] = $points_total + $award_points;
            $this->CI->db->update($this->CI->config->item('tbl_users'), $field_array);
        }
        return $data;
    }

    function deduct_points($data = '')
    {
        if ($data == '')
            return $data;

        $this->CI =& get_instance();
        if(isset($data['deduct_points'])){
            if($data['deduct_points'] == TRUE){
                $require_points = smp_lookup("require_points", $this->CI->config->item('tbl_products'), "product_id = " . $data['product_id']);
                $points_balance = smp_lookup("points_balance", $this->CI->config->item('tbl_users'), "user_id = " . $data['user_id']);
                $points_total = smp_lookup("points_total", $this->CI->config->item('tbl_users'), "user_id = " . $data['user_id']);

                $this->CI->db->where('user_id = ' . $data['user_id']);
                $field_array['points_balance'] = $points_balance - $require_points;
                $field_array['points_total'] = $points_total - $require_points;
                $this->CI->db->update($this->CI->config->item('tbl_users'), $field_array);
            }
        }
        return $data;
    }

}

/* End of file pointsmanager.php */