<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Module_updates {

        var $app_version = '1.14';
        var $app_name = 'updates';
        var $app_title = 'Updates';
        var $app_folder = 'updates';
        var $app_description = 'Author: Deep Arora <br> Support: <a href=http://sitemanpro.com/community target=_New>Click here</a> <br> Used for system upgrades.';

        /**************************************************/
        /***************  GETTER FUNCTIONS ****************/
        /**************************************************/
        function get_version()
        {
            return $this->app_version;
        }
        function get_app_name()
        {
            return $this->app_name;
        }
        function get_app_title()
        {
            return $this->app_title;
        }
        function get_app_description()
        {
            return $this->app_description;
        }
        function get_folder()
        {
            return $this->app_folder;
        }


        /**************************************************/
        /***************  INSTALL FUNCTION ****************/
        /**************************************************/
	function install()
	{
                $sql[] = "INSERT INTO `global_modules` (title, description, flg_enable, ordering, folder_name, file_name, icon, version) VALUES ('". ucfirst($this->app_name) ."', '". $this->app_description ."', 'Y', 999, '". $this->app_folder ."', 'updates', 'module-updates.gif', ". $this->app_version .")";
		foreach ($sql as $query)
		{
                    smp_execute($query);
		}

                unset($sql); //unset sql array to clear any previous queries;

		return TRUE;
	}


        /**************************************************/
        /***************  DISABLE FUNCTION ****************/
        /**************************************************/
	function disable()
	{
                $sql[] = "";
		foreach ($sql as $query)
		{
			smp_execute($query);
		}
		return FALSE;
	}

        /**************************************************/
        /***************  ACTIVATE FUNCTION ****************/
        /**************************************************/
        function activate()
	{
		$sql[] = "";
		foreach ($sql as $query)
		{
			smp_execute($query);
		}
		return FALSE;
	}

        /**************************************************/
        /***************  UNINSTALL FUNCTION ****************/
        /**************************************************/
	function uninstall()
	{
		$sql[] = "";
		foreach ($sql as $query)
		{
			smp_execute($query);
		}
		return FALSE;
	}



        /**************************************************/
        /***************  UPGRADE FUNCTION ****************/
        /**************************************************/
	function upgrade()
	{
            $current_version = smp_lookup('version', 'global_modules', 'LOWER(title) = \''. $this->app_name .'\'');
            $module_id = smp_lookup('module_id', 'global_modules', 'LOWER(title) = \''. $this->app_name .'\'');
            $current_app_version = smp_lookup('key_value', 'global_config', 'key_name = \'VERSION\'');

            if ($current_version == $this->app_version)
            {
                return TRUE;
            }

            /* Upgrade to Version 1.12 */
            if ($current_version < 1.12)
            {
                $sql[] = "ALTER TABLE  `global_submodules` ADD  `version` FLOAT NULL DEFAULT  '1';";
                $sql[] = "UPDATE `global_config` SET  `key_value` = 1.12 WHERE key_name = 'VERSION';";
                $sql[] = "UPDATE `global_modules` SET  `version` = 1.12 WHERE LOWER(title) = '". $this->app_name ."';";
                $sql[] = "INSERT INTO  `global_config` (`key_id` ,`key_name` ,`key_value` ,`key_reference` ,`key_title` ,`key_type` ,`key_help` ,`r_cre_id` ,`r_cre_time` ,`r_mod_id` ,`r_mod_time` ,`flg_enabled`)
                VALUES (NULL ,  'SHOP_GATEWAYS',  'Offline',  '0',  'Accept Payments Offline',  'SYSTEM', NULL ,  '1',  '0000-00-00 00:00:00',  '', NULL ,  'Y');";

                $sql[] = "INSERT INTO  `global_config` (`key_id` ,`key_name` ,`key_value` ,`key_reference` ,`key_title` ,`key_type` ,`key_help` ,`r_cre_id` ,`r_cre_time` ,`r_mod_id` ,`r_mod_time` ,`flg_enabled`)
                VALUES (NULL ,  'LICENSE',  '0',  '0',  'License',  'SYSTEM', NULL ,  '1',  '0000-00-00 00:00:00',  '', NULL ,  'Y');";

                $sql[] = "ALTER TABLE  `shop_products` ADD  `flg_enabled` CHAR( 3 ) NULL DEFAULT  'Yes' ;";

                $sql[] = "CREATE TABLE IF NOT EXISTS `global_logs` (
                  `log_id` int(11) NOT NULL AUTO_INCREMENT,
                  `log_ip` varchar(16) DEFAULT NULL,
                  `log_message` text,
                  `log_time` datetime DEFAULT NULL,
                  `log_type` varchar(12) DEFAULT NULL,
                  `log_by` varchar(64) DEFAULT NULL,
                  PRIMARY KEY (`log_id`),
                  KEY `log_id` (`log_id`)
                ) AUTO_INCREMENT=1 ;";

                $sql[] = "UPDATE  `global_config` SET  `key_value` =  'Hello {first_name},<br><br>
                Thank you for your buying - {item_name}<br><br>
                You can access your download/subscription here:<br><br>
                {download_link}<br><br>
                Your login details are:<br>
                Username: {username}<br>
                Password: {password}<br>
                <br>
                Best regards,<br>
                {admin_name},<br> '
                WHERE  `global_config`.`key_name` = 'TPL_EMAIL_NEW_ORDER_USER' LIMIT 1 ;";

                $sql[] = "UPDATE `global_config` SET  `key_value` = 1.12 WHERE key_name = 'VERSION';";
                $sql[] = "UPDATE `global_modules` SET  `version` = 1.12 WHERE LOWER(title) = '". $this->app_name ."';";


                foreach ($sql as $query)
		{
			smp_execute($query);
		}

                unset($sql); //unset sql array to clear any previous queries;
            }


            /* Upgrade to Version 1.13 */
            if ($current_version < 1.13)
            {
                $sql[] = "ALTER TABLE  `global_users` CHANGE  `card_num`  `card_num` VARCHAR( 128 ) DEFAULT NULL;";
                $sql[] = "ALTER TABLE  `global_users` CHANGE  `card_code`  `card_code` VARCHAR( 12 ) DEFAULT NULL;";


                $sql[] = "CREATE TABLE IF NOT EXISTS `global_hooks` (
                  `action_id` bigint(20) NOT NULL AUTO_INCREMENT,
                  `site_id` int(11) DEFAULT '0',
                  `action_hook` varchar(64) DEFAULT NULL,
                  `action_type` varchar(12) DEFAULT NULL,
                  `action_name` varchar(255) DEFAULT NULL,
                  `action_description` text,
                  `action_folder` varchar(24) DEFAULT NULL,
                  `action_file` varchar(128) DEFAULT NULL,
                  `action_function` varchar(128) DEFAULT NULL,
                  `flg_enable` char(3) DEFAULT 'Y',
                  `version` float DEFAULT '1',
                  PRIMARY KEY (`action_id`)
                ) AUTO_INCREMENT=1 ;";

                $sql[] = "UPDATE `global_config` SET  `key_value` = 1.13 WHERE key_name = 'VERSION';";
                $sql[] = "UPDATE `global_modules` SET  `version` = 1.13 WHERE LOWER(title) = '". $this->app_name ."';";



                foreach ($sql as $query)
		{
			smp_execute($query);
		}

                unset($sql); //unset sql array to clear any previous queries;
            }

            /* Upgrade to Version 1.14 */
            if ($current_version < 1.14)
            {
                $sql[] = "ALTER TABLE  `shop_products` ADD  `require_points` BIGINT NULL DEFAULT  '0';";
                $sql[] = "ALTER TABLE  `shop_products` ADD  `award_points` BIGINT NULL DEFAULT  '0';";
                $sql[] = "ALTER TABLE  `global_gateways` ADD  `flg_system` VARCHAR( 3 ) NULL DEFAULT  'N' AFTER  `flg_enabled` ;";

                $sql[] = "INSERT INTO  `global_rules` (`rule_id` ,`rule_name` ,`field_name` ,`field_label` ,`field_rule`)
                          VALUES (NULL ,  'users',  'points_total',  'Total Points',  'trim|integer|xss_clean'),
                          (NULL ,  'users',  'points_balance',  'Points Balance',  'trim|integer|xss_clean'),
                          (NULL ,  'products',  'require_points',  'Points Required',  'trim|integer|xss_clean'),
                          (NULL ,  'products',  'award_points',  'Award Points',  'trim|integer|xss_clean');";

                //$sql[] = "INSERT INTO  `global_config` VALUES (NULL ,  'SHOP_GATEWAYS',  'Points',  '0',  'Points Balance',  'USER', NULL ,  '1',  '0000-00-00 00:00:00', NULL , NULL ,  'Y');";
                $sql[] = "INSERT INTO `global_gateways` (`title`, `setting_1`, `setting_2`, `setting_3`, `setting_4`, `setting_5`, `setting_6`, `setting_7`, `setting_8`, `setting_9`, `setting_10`, `type`, `controller`, `flg_enabled`, `flg_system`, `r_cre_id`, `r_cre_time`, `r_mod_id`, `r_mod_time`) VALUES
                          ('User Points', 'Points', '', '', '', '', NULL, NULL, NULL, NULL, NULL, 'Points', 'points', 'Yes', 'Y', 1, '2011-03-05 01:03:07', 1, '2011-03-05 12:03:29');";

                $sql[] = "INSERT INTO `global_hooks` (`action_id`, `site_id`, `action_hook`, `action_type`, `action_name`, `action_description`, `action_folder`, `action_file`, `action_function`, `flg_enable`, `version`) VALUES
                            (NULL, 0, 'hook_shop_order_complete', 'library', 'award_points', NULL, 'hooks', 'pointsmanager', 'award_points', 'Y', 1),
                            (NULL, 0, 'hook_shop_order_complete', 'library', 'deduct_points', NULL, 'hooks', 'pointsmanager', 'deduct_points', 'Y', 1);";

                $sql[] = "INSERT INTO `global_submodule_files` (`page_id`, `submodule_id`, `folder_name`, `file_name`)
                          VALUES (NULL, 1, 'global', 'dashboard');";

                $sql[] = "INSERT INTO `global_config` (`key_id`, `key_name`, `key_value`, `key_reference`, `key_title`, `key_type`, `key_help`, `r_cre_id`, `r_cre_time`, `r_mod_id`, `r_mod_time`, `flg_enabled`) VALUES
                         (NULL, 'SUPPORT_LINK', 'http://www.sitemanpro.com/forum/', 0, 'Support Link', 'USER', 'You can specify your helpdesk URL here.', 1, '0000-00-00 00:00:00', NULL, NULL, 'Y');";

                $sql[] = "INSERT INTO `global_meta` (`meta_id`, `meta_name`, `meta_type`, `type_id`, `meta_key`, `meta_value`) VALUES
                         (NULL, 'dashboard', 'module', NULL, 'page_title', 'Dashboard'),
                         (NULL, 'dashboard', 'module', NULL, 'page_description', 'Welcome back to your business dashboard');";


                $sql[] = "UPDATE `global_config` SET  `key_value` = 1.14 WHERE key_name = 'VERSION';";
                $sql[] = "UPDATE `global_modules` SET  `version` = 1.14 WHERE LOWER(title) = '". $this->app_name ."';";

                $sql[] = "UPDATE  `global_modules` SET  `flg_enable` =  'Y', `file_name` =  'dashboard' WHERE  `module_id` =1 and `title` = 'Home' LIMIT 1 ;";


                foreach ($sql as $query)
		{
			smp_execute($query);
		}

                unset($sql); //unset sql array to clear any previous queries;
            }


            return TRUE;
	}


}
// END CLASS

/* End of file module_updates.php */
/* Location: ./app/modules/updates/module_updates.php */